unit schEjerciciosServer_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable, uDABusinessProcessor, FmtBCD, uROXMLIntf, schEjerciciosClient_Intf;

const
  { Delta rules ids 
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_darEjercicioActivoDelta = '{92BF2686-F344-464C-A6B2-AC5B79B3A840}';
  RID_EjerciciosDelta = '{8F263DB9-3ECD-4F2F-B263-867262A0AEA2}';

type
  { IdarEjercicioActivoDelta }
  IdarEjercicioActivoDelta = interface(IdarEjercicioActivo)
  ['{92BF2686-F344-464C-A6B2-AC5B79B3A840}']
    { Property getters and setters }
    function GetOldIDValue : Integer;

    { Properties }
    property OldID : Integer read GetOldIDValue;
  end;

  { TdarEjercicioActivoBusinessProcessorRules }
  TdarEjercicioActivoBusinessProcessorRules = class(TDABusinessProcessorRules, IdarEjercicioActivo, IdarEjercicioActivoDelta)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    function GetIDIsNull: Boolean; virtual;
    function GetOldIDValue: Integer; virtual;
    function GetOldIDIsNull: Boolean; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID : Integer read GetIDValue write SetIDValue;
    property IDIsNull : Boolean read GetIDIsNull write SetIDIsNull;
    property OldID : Integer read GetOldIDValue;
    property OldIDIsNull : Boolean read GetOldIDIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IEjerciciosDelta }
  IEjerciciosDelta = interface(IEjercicios)
  ['{8F263DB9-3ECD-4F2F-B263-867262A0AEA2}']
    { Property getters and setters }
    function GetOldIDValue : Integer;
    function GetOldID_EMPRESAValue : Integer;
    function GetOldNOMBREValue : String;
    function GetOldFECHA_INICIOValue : DateTime;
    function GetOldFECHA_FINValue : DateTime;
    function GetOldESTADOValue : String;
    function GetOldLONG_SUB_CUENTAValue : SmallInt;
    function GetOldID_ASIENTO_APERTURAValue : Integer;
    function GetOldID_ASIENTO_PERYGANValue : Integer;
    function GetOldID_ASIENTO_CIERREValue : Integer;
    function GetOldACTIVOValue : SmallInt;

    { Properties }
    property OldID : Integer read GetOldIDValue;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property OldFECHA_INICIO : DateTime read GetOldFECHA_INICIOValue;
    property OldFECHA_FIN : DateTime read GetOldFECHA_FINValue;
    property OldESTADO : String read GetOldESTADOValue;
    property OldLONG_SUB_CUENTA : SmallInt read GetOldLONG_SUB_CUENTAValue;
    property OldID_ASIENTO_APERTURA : Integer read GetOldID_ASIENTO_APERTURAValue;
    property OldID_ASIENTO_PERYGAN : Integer read GetOldID_ASIENTO_PERYGANValue;
    property OldID_ASIENTO_CIERRE : Integer read GetOldID_ASIENTO_CIERREValue;
    property OldACTIVO : SmallInt read GetOldACTIVOValue;
  end;

  { TEjerciciosBusinessProcessorRules }
  TEjerciciosBusinessProcessorRules = class(TDABusinessProcessorRules, IEjercicios, IEjerciciosDelta)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    function GetIDIsNull: Boolean; virtual;
    function GetOldIDValue: Integer; virtual;
    function GetOldIDIsNull: Boolean; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    function GetOldID_EMPRESAValue: Integer; virtual;
    function GetOldID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetNOMBREValue: String; virtual;
    function GetNOMBREIsNull: Boolean; virtual;
    function GetOldNOMBREValue: String; virtual;
    function GetOldNOMBREIsNull: Boolean; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    procedure SetNOMBREIsNull(const aValue: Boolean); virtual;
    function GetFECHA_INICIOValue: DateTime; virtual;
    function GetFECHA_INICIOIsNull: Boolean; virtual;
    function GetOldFECHA_INICIOValue: DateTime; virtual;
    function GetOldFECHA_INICIOIsNull: Boolean; virtual;
    procedure SetFECHA_INICIOValue(const aValue: DateTime); virtual;
    procedure SetFECHA_INICIOIsNull(const aValue: Boolean); virtual;
    function GetFECHA_FINValue: DateTime; virtual;
    function GetFECHA_FINIsNull: Boolean; virtual;
    function GetOldFECHA_FINValue: DateTime; virtual;
    function GetOldFECHA_FINIsNull: Boolean; virtual;
    procedure SetFECHA_FINValue(const aValue: DateTime); virtual;
    procedure SetFECHA_FINIsNull(const aValue: Boolean); virtual;
    function GetESTADOValue: String; virtual;
    function GetESTADOIsNull: Boolean; virtual;
    function GetOldESTADOValue: String; virtual;
    function GetOldESTADOIsNull: Boolean; virtual;
    procedure SetESTADOValue(const aValue: String); virtual;
    procedure SetESTADOIsNull(const aValue: Boolean); virtual;
    function GetLONG_SUB_CUENTAValue: SmallInt; virtual;
    function GetLONG_SUB_CUENTAIsNull: Boolean; virtual;
    function GetOldLONG_SUB_CUENTAValue: SmallInt; virtual;
    function GetOldLONG_SUB_CUENTAIsNull: Boolean; virtual;
    procedure SetLONG_SUB_CUENTAValue(const aValue: SmallInt); virtual;
    procedure SetLONG_SUB_CUENTAIsNull(const aValue: Boolean); virtual;
    function GetID_ASIENTO_APERTURAValue: Integer; virtual;
    function GetID_ASIENTO_APERTURAIsNull: Boolean; virtual;
    function GetOldID_ASIENTO_APERTURAValue: Integer; virtual;
    function GetOldID_ASIENTO_APERTURAIsNull: Boolean; virtual;
    procedure SetID_ASIENTO_APERTURAValue(const aValue: Integer); virtual;
    procedure SetID_ASIENTO_APERTURAIsNull(const aValue: Boolean); virtual;
    function GetID_ASIENTO_PERYGANValue: Integer; virtual;
    function GetID_ASIENTO_PERYGANIsNull: Boolean; virtual;
    function GetOldID_ASIENTO_PERYGANValue: Integer; virtual;
    function GetOldID_ASIENTO_PERYGANIsNull: Boolean; virtual;
    procedure SetID_ASIENTO_PERYGANValue(const aValue: Integer); virtual;
    procedure SetID_ASIENTO_PERYGANIsNull(const aValue: Boolean); virtual;
    function GetID_ASIENTO_CIERREValue: Integer; virtual;
    function GetID_ASIENTO_CIERREIsNull: Boolean; virtual;
    function GetOldID_ASIENTO_CIERREValue: Integer; virtual;
    function GetOldID_ASIENTO_CIERREIsNull: Boolean; virtual;
    procedure SetID_ASIENTO_CIERREValue(const aValue: Integer); virtual;
    procedure SetID_ASIENTO_CIERREIsNull(const aValue: Boolean); virtual;
    function GetACTIVOValue: SmallInt; virtual;
    function GetACTIVOIsNull: Boolean; virtual;
    function GetOldACTIVOValue: SmallInt; virtual;
    function GetOldACTIVOIsNull: Boolean; virtual;
    procedure SetACTIVOValue(const aValue: SmallInt); virtual;
    procedure SetACTIVOIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID : Integer read GetIDValue write SetIDValue;
    property IDIsNull : Boolean read GetIDIsNull write SetIDIsNull;
    property OldID : Integer read GetOldIDValue;
    property OldIDIsNull : Boolean read GetOldIDIsNull;
    property ID_EMPRESA : Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull : Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property OldID_EMPRESAIsNull : Boolean read GetOldID_EMPRESAIsNull;
    property NOMBRE : String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull : Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property OldNOMBREIsNull : Boolean read GetOldNOMBREIsNull;
    property FECHA_INICIO : DateTime read GetFECHA_INICIOValue write SetFECHA_INICIOValue;
    property FECHA_INICIOIsNull : Boolean read GetFECHA_INICIOIsNull write SetFECHA_INICIOIsNull;
    property OldFECHA_INICIO : DateTime read GetOldFECHA_INICIOValue;
    property OldFECHA_INICIOIsNull : Boolean read GetOldFECHA_INICIOIsNull;
    property FECHA_FIN : DateTime read GetFECHA_FINValue write SetFECHA_FINValue;
    property FECHA_FINIsNull : Boolean read GetFECHA_FINIsNull write SetFECHA_FINIsNull;
    property OldFECHA_FIN : DateTime read GetOldFECHA_FINValue;
    property OldFECHA_FINIsNull : Boolean read GetOldFECHA_FINIsNull;
    property ESTADO : String read GetESTADOValue write SetESTADOValue;
    property ESTADOIsNull : Boolean read GetESTADOIsNull write SetESTADOIsNull;
    property OldESTADO : String read GetOldESTADOValue;
    property OldESTADOIsNull : Boolean read GetOldESTADOIsNull;
    property LONG_SUB_CUENTA : SmallInt read GetLONG_SUB_CUENTAValue write SetLONG_SUB_CUENTAValue;
    property LONG_SUB_CUENTAIsNull : Boolean read GetLONG_SUB_CUENTAIsNull write SetLONG_SUB_CUENTAIsNull;
    property OldLONG_SUB_CUENTA : SmallInt read GetOldLONG_SUB_CUENTAValue;
    property OldLONG_SUB_CUENTAIsNull : Boolean read GetOldLONG_SUB_CUENTAIsNull;
    property ID_ASIENTO_APERTURA : Integer read GetID_ASIENTO_APERTURAValue write SetID_ASIENTO_APERTURAValue;
    property ID_ASIENTO_APERTURAIsNull : Boolean read GetID_ASIENTO_APERTURAIsNull write SetID_ASIENTO_APERTURAIsNull;
    property OldID_ASIENTO_APERTURA : Integer read GetOldID_ASIENTO_APERTURAValue;
    property OldID_ASIENTO_APERTURAIsNull : Boolean read GetOldID_ASIENTO_APERTURAIsNull;
    property ID_ASIENTO_PERYGAN : Integer read GetID_ASIENTO_PERYGANValue write SetID_ASIENTO_PERYGANValue;
    property ID_ASIENTO_PERYGANIsNull : Boolean read GetID_ASIENTO_PERYGANIsNull write SetID_ASIENTO_PERYGANIsNull;
    property OldID_ASIENTO_PERYGAN : Integer read GetOldID_ASIENTO_PERYGANValue;
    property OldID_ASIENTO_PERYGANIsNull : Boolean read GetOldID_ASIENTO_PERYGANIsNull;
    property ID_ASIENTO_CIERRE : Integer read GetID_ASIENTO_CIERREValue write SetID_ASIENTO_CIERREValue;
    property ID_ASIENTO_CIERREIsNull : Boolean read GetID_ASIENTO_CIERREIsNull write SetID_ASIENTO_CIERREIsNull;
    property OldID_ASIENTO_CIERRE : Integer read GetOldID_ASIENTO_CIERREValue;
    property OldID_ASIENTO_CIERREIsNull : Boolean read GetOldID_ASIENTO_CIERREIsNull;
    property ACTIVO : SmallInt read GetACTIVOValue write SetACTIVOValue;
    property ACTIVOIsNull : Boolean read GetACTIVOIsNull write SetACTIVOIsNull;
    property OldACTIVO : SmallInt read GetOldACTIVOValue;
    property OldACTIVOIsNull : Boolean read GetOldACTIVOIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

implementation

uses
  Variants, uROBinaryHelpers, uDAInterfaces;

{ TdarEjercicioActivoBusinessProcessorRules }
constructor TdarEjercicioActivoBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TdarEjercicioActivoBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TdarEjercicioActivoBusinessProcessorRules.GetIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_darEjercicioActivoID];
end;

function TdarEjercicioActivoBusinessProcessorRules.GetIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_darEjercicioActivoID]);
end;

function TdarEjercicioActivoBusinessProcessorRules.GetOldIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_darEjercicioActivoID];
end;

function TdarEjercicioActivoBusinessProcessorRules.GetOldIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_darEjercicioActivoID]);
end;

procedure TdarEjercicioActivoBusinessProcessorRules.SetIDValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_darEjercicioActivoID] := aValue;
end;

procedure TdarEjercicioActivoBusinessProcessorRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_darEjercicioActivoID] := Null;
end;


{ TEjerciciosBusinessProcessorRules }
constructor TEjerciciosBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TEjerciciosBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TEjerciciosBusinessProcessorRules.GetIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID];
end;

function TEjerciciosBusinessProcessorRules.GetIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID]);
end;

function TEjerciciosBusinessProcessorRules.GetOldIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosID];
end;

function TEjerciciosBusinessProcessorRules.GetOldIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosID]);
end;

procedure TEjerciciosBusinessProcessorRules.SetIDValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID] := aValue;
end;

procedure TEjerciciosBusinessProcessorRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID] := Null;
end;

function TEjerciciosBusinessProcessorRules.GetID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_EMPRESA];
end;

function TEjerciciosBusinessProcessorRules.GetID_EMPRESAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_EMPRESA]);
end;

function TEjerciciosBusinessProcessorRules.GetOldID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosID_EMPRESA];
end;

function TEjerciciosBusinessProcessorRules.GetOldID_EMPRESAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosID_EMPRESA]);
end;

procedure TEjerciciosBusinessProcessorRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_EMPRESA] := aValue;
end;

procedure TEjerciciosBusinessProcessorRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_EMPRESA] := Null;
end;

function TEjerciciosBusinessProcessorRules.GetNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosNOMBRE];
end;

function TEjerciciosBusinessProcessorRules.GetNOMBREIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosNOMBRE]);
end;

function TEjerciciosBusinessProcessorRules.GetOldNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosNOMBRE];
end;

function TEjerciciosBusinessProcessorRules.GetOldNOMBREIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosNOMBRE]);
end;

procedure TEjerciciosBusinessProcessorRules.SetNOMBREValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosNOMBRE] := aValue;
end;

procedure TEjerciciosBusinessProcessorRules.SetNOMBREIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosNOMBRE] := Null;
end;

function TEjerciciosBusinessProcessorRules.GetFECHA_INICIOValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosFECHA_INICIO];
end;

function TEjerciciosBusinessProcessorRules.GetFECHA_INICIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosFECHA_INICIO]);
end;

function TEjerciciosBusinessProcessorRules.GetOldFECHA_INICIOValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosFECHA_INICIO];
end;

function TEjerciciosBusinessProcessorRules.GetOldFECHA_INICIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosFECHA_INICIO]);
end;

procedure TEjerciciosBusinessProcessorRules.SetFECHA_INICIOValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosFECHA_INICIO] := aValue;
end;

procedure TEjerciciosBusinessProcessorRules.SetFECHA_INICIOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosFECHA_INICIO] := Null;
end;

function TEjerciciosBusinessProcessorRules.GetFECHA_FINValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosFECHA_FIN];
end;

function TEjerciciosBusinessProcessorRules.GetFECHA_FINIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosFECHA_FIN]);
end;

function TEjerciciosBusinessProcessorRules.GetOldFECHA_FINValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosFECHA_FIN];
end;

function TEjerciciosBusinessProcessorRules.GetOldFECHA_FINIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosFECHA_FIN]);
end;

procedure TEjerciciosBusinessProcessorRules.SetFECHA_FINValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosFECHA_FIN] := aValue;
end;

procedure TEjerciciosBusinessProcessorRules.SetFECHA_FINIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosFECHA_FIN] := Null;
end;

function TEjerciciosBusinessProcessorRules.GetESTADOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosESTADO];
end;

function TEjerciciosBusinessProcessorRules.GetESTADOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosESTADO]);
end;

function TEjerciciosBusinessProcessorRules.GetOldESTADOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosESTADO];
end;

function TEjerciciosBusinessProcessorRules.GetOldESTADOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosESTADO]);
end;

procedure TEjerciciosBusinessProcessorRules.SetESTADOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosESTADO] := aValue;
end;

procedure TEjerciciosBusinessProcessorRules.SetESTADOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosESTADO] := Null;
end;

function TEjerciciosBusinessProcessorRules.GetLONG_SUB_CUENTAValue: SmallInt;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosLONG_SUB_CUENTA];
end;

function TEjerciciosBusinessProcessorRules.GetLONG_SUB_CUENTAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosLONG_SUB_CUENTA]);
end;

function TEjerciciosBusinessProcessorRules.GetOldLONG_SUB_CUENTAValue: SmallInt;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosLONG_SUB_CUENTA];
end;

function TEjerciciosBusinessProcessorRules.GetOldLONG_SUB_CUENTAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosLONG_SUB_CUENTA]);
end;

procedure TEjerciciosBusinessProcessorRules.SetLONG_SUB_CUENTAValue(const aValue: SmallInt);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosLONG_SUB_CUENTA] := aValue;
end;

procedure TEjerciciosBusinessProcessorRules.SetLONG_SUB_CUENTAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosLONG_SUB_CUENTA] := Null;
end;

function TEjerciciosBusinessProcessorRules.GetID_ASIENTO_APERTURAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_ASIENTO_APERTURA];
end;

function TEjerciciosBusinessProcessorRules.GetID_ASIENTO_APERTURAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_ASIENTO_APERTURA]);
end;

function TEjerciciosBusinessProcessorRules.GetOldID_ASIENTO_APERTURAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosID_ASIENTO_APERTURA];
end;

function TEjerciciosBusinessProcessorRules.GetOldID_ASIENTO_APERTURAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosID_ASIENTO_APERTURA]);
end;

procedure TEjerciciosBusinessProcessorRules.SetID_ASIENTO_APERTURAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_ASIENTO_APERTURA] := aValue;
end;

procedure TEjerciciosBusinessProcessorRules.SetID_ASIENTO_APERTURAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_ASIENTO_APERTURA] := Null;
end;

function TEjerciciosBusinessProcessorRules.GetID_ASIENTO_PERYGANValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_ASIENTO_PERYGAN];
end;

function TEjerciciosBusinessProcessorRules.GetID_ASIENTO_PERYGANIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_ASIENTO_PERYGAN]);
end;

function TEjerciciosBusinessProcessorRules.GetOldID_ASIENTO_PERYGANValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosID_ASIENTO_PERYGAN];
end;

function TEjerciciosBusinessProcessorRules.GetOldID_ASIENTO_PERYGANIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosID_ASIENTO_PERYGAN]);
end;

procedure TEjerciciosBusinessProcessorRules.SetID_ASIENTO_PERYGANValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_ASIENTO_PERYGAN] := aValue;
end;

procedure TEjerciciosBusinessProcessorRules.SetID_ASIENTO_PERYGANIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_ASIENTO_PERYGAN] := Null;
end;

function TEjerciciosBusinessProcessorRules.GetID_ASIENTO_CIERREValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_ASIENTO_CIERRE];
end;

function TEjerciciosBusinessProcessorRules.GetID_ASIENTO_CIERREIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_ASIENTO_CIERRE]);
end;

function TEjerciciosBusinessProcessorRules.GetOldID_ASIENTO_CIERREValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosID_ASIENTO_CIERRE];
end;

function TEjerciciosBusinessProcessorRules.GetOldID_ASIENTO_CIERREIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosID_ASIENTO_CIERRE]);
end;

procedure TEjerciciosBusinessProcessorRules.SetID_ASIENTO_CIERREValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_ASIENTO_CIERRE] := aValue;
end;

procedure TEjerciciosBusinessProcessorRules.SetID_ASIENTO_CIERREIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosID_ASIENTO_CIERRE] := Null;
end;

function TEjerciciosBusinessProcessorRules.GetACTIVOValue: SmallInt;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosACTIVO];
end;

function TEjerciciosBusinessProcessorRules.GetACTIVOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosACTIVO]);
end;

function TEjerciciosBusinessProcessorRules.GetOldACTIVOValue: SmallInt;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosACTIVO];
end;

function TEjerciciosBusinessProcessorRules.GetOldACTIVOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EjerciciosACTIVO]);
end;

procedure TEjerciciosBusinessProcessorRules.SetACTIVOValue(const aValue: SmallInt);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosACTIVO] := aValue;
end;

procedure TEjerciciosBusinessProcessorRules.SetACTIVOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EjerciciosACTIVO] := Null;
end;


initialization
  RegisterBusinessProcessorRules(RID_darEjercicioActivoDelta, TdarEjercicioActivoBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_EjerciciosDelta, TEjerciciosBusinessProcessorRules);

end.
